.386
.model flat,stdcall
option casemap:none

include ButtonEx.inc

.code

CreateButtonExClass proc hInstance:HINSTANCE
	LOCAL	wc:WNDCLASSEX
	
	call InitCommonControls
	
	push	hInstance
	pop		g_hInstance
	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_GLOBALCLASS or CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW	or CS_PARENTDC
	mov		wc.lpfnWndProc,offset ButtonProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,4		;Holds memory handle
	push	hInstance
	pop		wc.hInstance
	mov		wc.hbrBackground,NULL
	mov		wc.lpszMenuName,NULL
	mov		wc.lpszClassName,offset szButtonEx
	mov		eax,NULL
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	ret
CreateButtonExClass endp

ButtonProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hWndUnderMouse	:HWND
	LOCAL hWndActive		:HWND
	LOCAL tme				:TRACKMOUSEEVENT
	LOCAL pntMousePos		:POINT
	
	mov eax,uMsg
	
	.if eax==WM_CREATE
		inc g_nDllRefs
		cmp g_hThemeDll,NULL
		jne @F
		invoke LoadLibrary,offset szUxThemeDll
		cmp eax,NULL
		je @F
		mov g_hThemeDll,eax
		invoke GetProcAddress,eax,offset szIsAppThemed
		call eax
		cmp eax,NULL
		je @F
		invoke OpenTheme,hWnd
@@:
		invoke GetProcessHeap
		invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,sizeof STRUCT_BUTTONEX
		push eax
		
		mov [eax].STRUCT_BUTTONEX.SoundStructOver.nSoundID,0
		push g_hInstance
		pop [eax].STRUCT_BUTTONEX.SoundStructOver.hMod
		mov [eax].STRUCT_BUTTONEX.SoundStructOver.dwFlags,SND_RESOURCE or SND_ASYNC or SND_NODEFAULT or SND_NOWAIT
		
		mov [eax].STRUCT_BUTTONEX.SoundStructClick.nSoundID,0
		push g_hInstance
		pop [eax].STRUCT_BUTTONEX.SoundStructClick.hMod
		mov [eax].STRUCT_BUTTONEX.SoundStructClick.dwFlags,SND_RESOURCE or SND_ASYNC or SND_NODEFAULT or SND_NOWAIT
		
		invoke SetWindowLong,hWnd,0,eax
		invoke SendMessage,hWnd,BTNEXM_SETDEFAULTCOLORS,0,0
  		invoke SendMessage,hWnd,BTNEXM_SETPRESSEDSTYLE,BTNEXST_PRESSED_LEFTRIGHT,FALSE
		pop eax
		invoke GetWindowText,hWnd,addr [eax].STRUCT_BUTTONEX.szTitle,sizeof STRUCT_BUTTONEX.szTitle
		
	.elseif eax==WM_SETCURSOR
		invoke GetWindowLong,hWnd,0
		.if [eax].STRUCT_BUTTONEX.hCursor
			invoke SetCursor,[eax].STRUCT_BUTTONEX.hCursor
			mov eax,TRUE
			ret
		.endif
			
	.elseif eax==WM_ENABLE
		invoke GetWindowLong,hWnd,0
		.if wParam
			and [eax].STRUCT_BUTTONEX.States,BTNEXS_DISABLED	; Clear BTNEXS_DISABLED
		.else
			or [eax].STRUCT_BUTTONEX.States,BTNEXS_DISABLED		; Set BTNEXS_DISABLED
		.endif
		invoke InvalidateRect,hWnd,NULL,TRUE
		
	.elseif eax == WM_NOTIFY
		mov	eax,lParam
        mov eax,(NMHDR ptr [eax]).code
        .if eax==TTN_NEEDTEXT
			invoke GetWindowLong,hWnd,0
        	mov ecx,[eax].STRUCT_BUTTONEX.lpToolTipText
        	mov eax,lParam
        	mov (TOOLTIPTEXT ptr [eax]).lpszText,ecx
        .endif
    	
    .elseif eax==WM_SETFOCUS
		invoke GetWindowLong,hWnd,0
		or [eax].STRUCT_BUTTONEX.States,BTNEXS_FOCUSED			; Set BTNEXS_FOCUSED
		.if g_nDefBtnID
			invoke GetWindowLong,hWnd,GWL_ID
			push esi
			mov esi,eax
			invoke GetParent,hWnd
			push edi
			mov edi,eax
			invoke GetDlgItem,eax,g_nDefBtnID
			push ebx
			mov ebx,eax
			invoke GetWindowLong,eax,0
			.if eax
				.if !(esi==g_nDefBtnID)
					and [eax].STRUCT_BUTTONEX.States,-1 xor BTNEXS_DEFAULT	; Clear BTNEXS_DEFAULT
					invoke InvalidateRect,ebx,NULL,TRUE
					invoke SendMessage,edi,DM_SETDEFID,esi,0
				.else
					or [eax].STRUCT_BUTTONEX.States,BTNEXS_DEFAULT	; Set BTNEXS_DEFAULT
					invoke GetParent,hWnd
					invoke SendMessage,eax,DM_SETDEFID,g_nDefBtnID,0
				.endif
			.endif
			pop ebx
			pop edi
			pop esi
		.endif
		invoke InvalidateRect,hWnd,NULL,TRUE
		mov eax,FALSE
		ret
		
	.elseif eax==WM_KILLFOCUS
		invoke GetWindowLong,hWnd,0
		and [eax].STRUCT_BUTTONEX.States,-1 xor BTNEXS_FOCUSED	; Clear BTNEXS_FOCUSED
		and [eax].STRUCT_BUTTONEX.States,-1 xor BTNEXS_DEFAULT	; Clear BTNEXS_DEFAULT
		.if g_nDefBtnID
			invoke GetParent,hWnd
			push edi
			mov edi,eax
			invoke GetDlgItem,eax,g_nDefBtnID
			push ebx
			mov ebx,eax
			invoke GetWindowLong,eax,0
			.if eax
				or [eax].STRUCT_BUTTONEX.States,BTNEXS_DEFAULT	; Set BTNEXS_DEFAULT
				invoke SendMessage,edi,DM_SETDEFID,g_nDefBtnID,0
				invoke InvalidateRect,ebx,NULL,TRUE
			.endif
			pop edi
			pop ebx
		.endif
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		invoke CancelHover,hWnd
		mov eax,FALSE
		ret
	
	.elseif eax==WM_THEMECHANGED
		.if g_hTheme
			call CloseTheme
			invoke OpenTheme,hWnd
		.endif
		
	.elseif eax==WM_SYSCOLORCHANGE
		invoke GetWindowLong,hWnd,0
		push eax
		invoke DeleteDC,[eax].STRUCT_BUTTONEX.dcBk
		pop eax
		invoke DeleteObject,[eax].STRUCT_BUTTONEX.bmpBk
		invoke SetDefaultColors,hWnd
		ret

	.elseif eax==WM_GETDLGCODE
		invoke GetWindowLong,hWnd,0
		; Is default button ?
		test [eax].STRUCT_BUTTONEX.States,BTNEXS_DEFAULT
		.if !zero?
			mov eax,DLGC_DEFPUSHBUTTON
		.else
			mov eax,DLGC_UNDEFPUSHBUTTON
		.endif
		ret

	.elseif eax==WM_KEYDOWN
		.if wParam==VK_SPACE
			invoke SendMessage,hWnd,WM_LBUTTONDOWN,0,0
		.endif
		mov eax,0
		ret
	
	.elseif eax==WM_KEYUP
		.if wParam==VK_SPACE
			invoke SendMessage,hWnd,WM_LBUTTONUP,0,0
		.endif
		mov eax,0
		ret
		
	.elseif eax==WM_MOUSEMOVE
		push ebx
		mov	ecx,lParam
		movzx edx,cx	; xPos -> edx
		shr	ecx,16		; yPos -> ecx
		mov pntMousePos.x,edx
		mov pntMousePos.y,ecx
		mov hWndActive,NULL
		mov	hWndUnderMouse,NULL
		
		invoke ClientToScreen,hWnd,addr pntMousePos
		mov hWndUnderMouse,$invoke(WindowFromPoint,pntMousePos.x,pntMousePos.y)
		
		invoke GetWindowLong,hWnd,0
		mov ebx,eax
		
		; If the mouse enter the button with the left button pressed then do nothing
		test wParam,MK_LBUTTON
		.if !zero?
			; Is mouse over the button ?
			test [ebx].STRUCT_BUTTONEX.States,BTNEXS_MOUSEONBTN
			 .if zero?
			 	pop ebx
			 	ret
			.endif
		.endif
		
		; Is the button not flat ?
		test [ebx].STRUCT_BUTTONEX.States,BTNEXS_FLAT
		.if zero?		
			.if g_bHover
				mov g_bHover,FALSE
				call _TrackMouse
			.endif
			pop ebx
			ret
		.endif

		; Always hilight button ?	
		test [ebx].STRUCT_BUTTONEX.States,BTNEXS_ALWAYSTRACK
		.if zero?
			mov hWndActive,$invoke(GetActiveWindow)
		.else
			mov hWndActive,TRUE
		.endif
		
		mov ecx,hWnd
		.if(hWndUnderMouse && (hWndUnderMouse == ecx) && hWndActive)
			; Is mouse over the button ?
			test [ebx].STRUCT_BUTTONEX.States,BTNEXS_MOUSEONBTN
			.if zero?
				or [ebx].STRUCT_BUTTONEX.States,BTNEXS_MOUSEONBTN		; Set BTNEXS_MOUSEONBTN
				invoke InvalidateRect,hWnd,NULL,FALSE
				call _TrackMouse
			.endif
		;.else 
		;	invoke CancelHover,hWnd
		.endif
		pop ebx
		ret
		
_TrackMouse:
		mov tme.cbSize,sizeof TRACKMOUSEEVENT
		mov tme.dwFlags,TME_LEAVE or TME_HOVER
		mov eax,hWnd
		mov tme.hwndTrack,eax
		mov tme.dwHoverTime,10
		invoke TrackMouseEvent,addr tme
		ret
		
	.elseif	eax==WM_MOUSEHOVER
		invoke GetWindowLong,hWnd,0
		.if [eax].STRUCT_BUTTONEX.SoundStructOver.nSoundID
			invoke PlaySound,[eax].STRUCT_BUTTONEX.SoundStructOver.nSoundID,\
				[eax].STRUCT_BUTTONEX.SoundStructOver.hMod,[eax].STRUCT_BUTTONEX.SoundStructOver.dwFlags
		.endif
		mov eax,FALSE
		ret
		
	.elseif eax==WM_MOUSELEAVE
		mov g_bHover,TRUE
		invoke CancelHover,hWnd
		mov eax,FALSE
		ret
		
	.elseif eax==WM_LBUTTONUP
		invoke GetWindowLong,hWnd,0
		push ebx
		mov ebx,eax
		mov	ecx,lParam
		movzx edx,cx	; xPos -> edx
		shr	ecx,16		; yPos -> ecx
		mov pntMousePos.x,edx
		mov pntMousePos.y,ecx
		
		; Is the button pressed ? 
		test [ebx].STRUCT_BUTTONEX.States,BTNEXS_PRESSED
		.if !zero?
			or [ebx].STRUCT_BUTTONEX.States,BTNEXS_FOCUSED					; Set BTNEXS_FOCUSED
			and [ebx].STRUCT_BUTTONEX.States,-1 xor BTNEXS_PRESSED			; Clear BTNEXS_PRESSED

			invoke GetWindowLong,hWnd,GWL_ID
			push eax
			invoke GetParent,hWnd
			pop	edx
			mov ecx,BN_CLICKED
			shl ecx,16
			or edx,ecx
			invoke PostMessage,eax,WM_COMMAND,edx,hWnd	; Send a WM_COMMAND to parent window
			
			; Is the button a checkbox ?
			test [ebx].STRUCT_BUTTONEX.States,BTNEXS_CHECKBOX
			.if !zero?
				; Xor checkbox state
				test [ebx].STRUCT_BUTTONEX.States,BTNEXS_CHECK
				.if !zero?
					and [ebx].STRUCT_BUTTONEX.States,-1 xor BTNEXS_CHECK	; Clear BTNEXS_CHECK
				.else
					or [ebx].STRUCT_BUTTONEX.States,BTNEXS_CHECK			; Set BTNEXS_CHECK
				.endif
			.endif
			invoke InvalidateRect,hWnd,NULL,TRUE
		.endif
		pop ebx
		mov eax,FALSE
		ret
		
	.elseif eax==WM_LBUTTONDOWN
		invoke GetWindowLong,hWnd,0
		push ebx
		mov ebx,eax
		.if [ebx].STRUCT_BUTTONEX.SoundStructClick.nSoundID
			invoke PlaySound,[ebx].STRUCT_BUTTONEX.SoundStructClick.nSoundID,\
				[ebx].STRUCT_BUTTONEX.SoundStructClick.hMod,[ebx].STRUCT_BUTTONEX.SoundStructClick.dwFlags
		.endif
		or [ebx].STRUCT_BUTTONEX.States,BTNEXS_PRESSED or BTNEXS_FOCUSED	; Set BTNEXS_PRESSED+BTNEXS_FOCUSED
		invoke InvalidateRect,hWnd,NULL,TRUE
		invoke SetFocus,hWnd
		pop ebx
		mov eax,FALSE
		ret
	
	.elseif eax==BM_GETCHECK
		invoke GetWindowLong,hWnd,0
		test [eax].STRUCT_BUTTONEX.States,BTNEXS_CHECK
		.if !zero?
			mov eax,TRUE
		.else
			xor eax,eax
		.endif
		ret
	
	.elseif eax==WM_PAINT
		invoke PaintButton,hWnd
		mov eax,FALSE
		ret
		
	.elseif eax==WM_SIZE
		invoke GetWindowLong,hWnd,0
		invoke GetClientRect,hWnd,addr [eax].STRUCT_BUTTONEX.rcRect
		
	.elseif eax==WM_DESTROY
		push ebx
		invoke GetWindowLong,hWnd,0
		mov		ebx,eax

		.if [ebx].STRUCT_BUTTONEX.dcBk
			invoke SelectObject,[ebx].STRUCT_BUTTONEX.dcBk,[ebx].STRUCT_BUTTONEX.pbmpOldBk
			.if [ebx].STRUCT_BUTTONEX.bmpBk
				invoke DeleteObject,[ebx].STRUCT_BUTTONEX.bmpBk
			.endif
			invoke DeleteDC,[ebx].STRUCT_BUTTONEX.dcBk
		.endif
		invoke FreeResources,hWnd
		
		dec g_nDllRefs
		.if g_hThemeDll
			.if !g_nDllRefs
				.if g_hTheme
					call CloseTheme
				.endif
				invoke FreeLibrary,g_hThemeDll
				mov g_hThemeDll,NULL
			.endif
		.endif
		
		invoke GetProcessHeap
		push edi
		mov edi,eax
		.if [ebx].STRUCT_BUTTONEX.hToolTipWnd
			invoke DestroyWindow,[ebx].STRUCT_BUTTONEX.hToolTipWnd
			invoke HeapFree,edi,NULL,[ebx].STRUCT_BUTTONEX.lpToolTipText
		.endif
		invoke HeapFree,edi,NULL,ebx
		pop edi
		pop ebx
	
	.elseif eax==WM_SETTEXT
		invoke GetWindowLong,hWnd,0
		invoke lstrcpyn,addr [eax].STRUCT_BUTTONEX.szTitle,lParam,sizeof STRUCT_BUTTONEX.szTitle
		invoke InvalidateRect,hWnd,NULL,TRUE
		
	.elseif eax==WM_SETFONT
		invoke GetWindowLong,hWnd,0
		mov ecx,wParam
		mov [eax].STRUCT_BUTTONEX.hDefaultFont,ecx
		invoke InvalidateRect,hWnd,NULL,TRUE
	
	.elseif eax==BTNEXM_SETBITMAP
		invoke SetBitmap,hWnd,wParam,lParam
			
	.elseif eax==BTNEXM_SETICON
		invoke SetIcon,hWnd,wParam,lParam
		
	.elseif eax==BTNEXM_ALIGN_HORIZ
		invoke GetWindowLong,hWnd,0
		; Set BTNEXST_ALIGN_HORIZ
		and [eax].STRUCT_BUTTONEX.States,-1 xor BTNEXS_ALIGN
		or 	[eax].STRUCT_BUTTONEX.States,BTNEXST_ALIGN_HORIZ
		
	.elseif eax==BTNEXM_ALIGN_VERT
		invoke GetWindowLong,hWnd,0
		; Set BTNEXST_ALIGN_HORIZ
		and [eax].STRUCT_BUTTONEX.States,-1 xor BTNEXS_ALIGN
		or 	[eax].STRUCT_BUTTONEX.States,BTNEXST_ALIGN_VERT
	
	.elseif eax==BTNEXM_ALIGN_HORIZRIGHT
		invoke GetWindowLong,hWnd,0
		; Set BTNEXST_ALIGN_HORIZ
		and [eax].STRUCT_BUTTONEX.States,-1 xor BTNEXS_ALIGN
		or 	[eax].STRUCT_BUTTONEX.States,BTNEXST_ALIGN_HORIZ_RIGHT
	
	.elseif eax==BTNEXM_SETBKGRCOL_IN
		invoke SetColor,hWnd,BTNEXST_COLOR_BK_IN,wParam
			
	.elseif eax==BTNEXM_SETTEXTCOL_IN
		invoke SetColor,hWnd,BTNEXST_COLOR_FG_IN,wParam
	
	.elseif eax==BTNEXM_SETBKGRCOL_OUT
		invoke SetColor,hWnd,BTNEXST_COLOR_BK_OUT,wParam
	
	.elseif eax==BTNEXM_SETTEXTCOL_OUT
		invoke SetColor,hWnd,BTNEXST_COLOR_FG_OUT,wParam
	
	.elseif eax==BTNEXM_SETBKGRCOL_FOCUS
		invoke SetColor,hWnd,BTNEXST_COLOR_BK_FOCUS,wParam
	
	.elseif eax==BTNEXM_SETTEXTCOL_FOCUS
		invoke SetColor,hWnd,BTNEXST_COLOR_FG_FOCUS,wParam
	
	.elseif eax==BTNEXM_SETDEFAULTCOLORS
		invoke SetDefaultColors,hWnd
		
	.elseif eax==BTNEXM_SETCURSOR
		; Store cursor
		invoke GetWindowLong,hWnd,0
		push ebx
		mov ebx,eax
		invoke LoadImage,g_hInstance,wParam,IMAGE_CURSOR,0,0,LR_DEFAULTSIZE
		mov [ebx].STRUCT_BUTTONEX.hCursor,eax
		pop ebx
		; Repaint the button
		.if lParam 
			invoke InvalidateRect,hWnd,NULL,TRUE
		.endif
	
	.elseif eax==BTNEXM_SETTOOLTIPTEXT
		push ebx
		invoke GetWindowLong,hWnd,0
		mov		ebx,eax
		.if ![ebx].STRUCT_BUTTONEX.hToolTipWnd
			invoke CreateWindowEx,NULL,offset szToolTips,NULL,TTS_ALWAYSTIP,\
				CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,hWnd,NULL,g_hInstance,NULL
			mov [ebx].STRUCT_BUTTONEX.hToolTipWnd,eax
			mov g_ti.cbSize,sizeof TOOLINFO
			mov g_ti.uFlags,TTF_IDISHWND or TTF_SUBCLASS 
			mov eax,hWnd
			mov g_ti.hWnd,eax
			mov g_ti.uId,eax
			mov g_ti.lpszText,LPSTR_TEXTCALLBACK
			invoke SendMessage,[ebx].STRUCT_BUTTONEX.hToolTipWnd,TTM_ADDTOOL,NULL,addr g_ti
			invoke SendMessage,[ebx].STRUCT_BUTTONEX.hToolTipWnd,TTM_SETDELAYTIME,TTDT_INITIAL,600
			; Allocate tooltips' text buffer (80 bytes) 
			invoke GetProcessHeap
			invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,050h
			mov [ebx].STRUCT_BUTTONEX.lpToolTipText,eax
		.endif
		invoke lstrcpyn,[ebx].STRUCT_BUTTONEX.lpToolTipText,lParam,050h
		pop ebx
			
	.elseif eax==BTNEXM_SETPRESSEDSTYLE
		invoke GetWindowLong,hWnd,0
		.if wParam==BTNEXST_PRESSED_LEFTRIGHT
			mov [eax].STRUCT_BUTTONEX.ptPressedOffset.x,1
			mov [eax].STRUCT_BUTTONEX.ptPressedOffset.y,1
		.elseif wParam==BTNEXST_PRESSED_LEFTRIGHT
			mov [eax].STRUCT_BUTTONEX.ptPressedOffset.x,0
			mov [eax].STRUCT_BUTTONEX.ptPressedOffset.y,2
		.endif
		.if lParam	
			invoke InvalidateRect,NULL,hWnd,TRUE
		.endif
			
	.elseif eax==BTNEXM_SETSOUND
		invoke SetSound,hWnd,wParam,lParam
	
	.elseif eax==BTNEXM_SETXPBUTTON
		invoke GetWindowLong,hWnd,0
		.if g_hTheme
			or [eax].STRUCT_BUTTONEX.States,BTNEXST_XPBUTTON
		.endif
		
	.elseif eax==BTNEXM_SETDEFAULT
		invoke GetWindowLong,hWnd,0
		or [eax].STRUCT_BUTTONEX.States,BTNEXS_DEFAULT
		invoke GetParent,hWnd
		push eax
		invoke GetWindowLong,hWnd,GWL_ID
		pop edx
		mov g_nDefBtnID,eax
		invoke SendMessage,edx,DM_SETDEFID,eax,0
		
	.elseif eax==BTNEXM_SETFLAT
		invoke GetWindowLong,hWnd,0
		or [eax].STRUCT_BUTTONEX.States,BTNEXST_FLAT
	
	.elseif eax==BTNEXM_SETNORMAL
		invoke GetWindowLong,hWnd,0
		or [eax].STRUCT_BUTTONEX.States,BTNEXST_NORMAL
	
	.elseif eax==BTNEXM_SETXPCHECKBOX
		invoke GetWindowLong,hWnd,0
		.if g_hTheme	
			or [eax].STRUCT_BUTTONEX.States,BTNEXST_XPCHECKBOX
		.else
			or [eax].STRUCT_BUTTONEX.States,BTNEXST_FLATCHECKBOX
		.endif
		
	.elseif eax==BTNEXM_SETFLATCHECKBOX	
		invoke GetWindowLong,hWnd,0
		or [eax].STRUCT_BUTTONEX.States,BTNEXST_FLATCHECKBOX
		
	.elseif eax==BTNEXM_SHOWDISABLEIMAGE
		invoke GetWindowLong,hWnd,0
		or [eax].STRUCT_BUTTONEX.States,BTNEXS_DISABLEDIMAGE
					
	.elseif eax==BTNEXM_SETALWAYSTRACK
		invoke GetWindowLong,hWnd,0
		or [eax].STRUCT_BUTTONEX.States,BTNEXS_ALWAYSTRACK
	
	.endif 
	
	invoke DefWindowProc,hWnd,uMsg,wParam,lParam
	ret
ButtonProc endp

PaintButton proc uses ebx esi edi hWnd:HWND
	LOCAL	ps				:PAINTSTRUCT
	LOCAL	hWhitePen		:HPEN
	LOCAL 	hLtGrayPen		:HPEN
	LOCAL 	hDrGrayPen		:HPEN
	LOCAL 	hBlackPen		:HPEN
	LOCAL 	hOldPen			:HPEN	
	LOCAL   rect			:RECT
	LOCAL 	focusRect		:RECT
	LOCAL	centerRect		:RECT
	LOCAL 	captionRect		:RECT
	LOCAL 	lenTitle		:DWORD
	LOCAL 	lpTitle			:DWORD
	LOCAL	pData			:DWORD
	
	invoke GetWindowLong,hWnd,0
	mov pData,eax
	
	; Is the button a checkbox ?
	test [eax].STRUCT_BUTTONEX.States,BTNEXS_CHECKBOX
	.if !zero?
		; Checkbox state ?
		test [eax].STRUCT_BUTTONEX.States,BTNEXS_CHECK 
		 .if !zero?
		 	; Set pressed
			or [eax].STRUCT_BUTTONEX.States,BTNEXS_PRESSED	; Set BTNEXS_PRESSED
		.endif
	.endif
	
	invoke CopyRect,addr rect,addr [eax].STRUCT_BUTTONEX.rcRect
	invoke BeginPaint,hWnd,addr ps
	invoke SetBkMode,ps.hdc,TRANSPARENT
	
	mov ebx,pData
	; Is a flat button ?
	test [ebx].STRUCT_BUTTONEX.States,BTNEXS_FLAT
	.if zero?
		; Is button focused ?
		mov ecx,BTNEXS_FOCUSED
		and ecx,[ebx].STRUCT_BUTTONEX.States		; Test BTNEXS_FOCUSED
		
		; Is default button ?
		mov edx,BTNEXS_DEFAULT
		and edx,[ebx].STRUCT_BUTTONEX.States		; Test BTNEXS_DEFAULT
		
		.if(ecx || edx)
			invoke CreateSolidBrush,0
			invoke FrameRect,ps.hdc,addr rect,eax
			invoke InflateRect,addr rect,-1,-1
		.endif
	.endif
	
	mov ebx,pData
	; Paint button background
	; Draw transparent ?
	.if ps.fErase
		test [ebx].STRUCT_BUTTONEX.States,BTNEXS_TRANSPARENT
		.if !zero?
			invoke PaintBk,hWnd,ps.hdc
		.else
			invoke DrawBackground,hWnd,ps.hdc,addr rect
		.endif
	.endif
	
	mov ebx,pData
	; Draw pressed button
	; Is button pressed ?
	test [ebx].STRUCT_BUTTONEX.States,BTNEXS_PRESSED
	.if !zero?
		; Is a flat button ?
		test [ebx].STRUCT_BUTTONEX.States,BTNEXS_FLAT
		.if !zero?
			; Draw border ?
			test [ebx].STRUCT_BUTTONEX.States,BTNEXS_BORDER
			.if !zero?
				invoke DrawBorder,hWnd,ps.hdc, addr rect
			.endif
		.else    
			invoke GetSysColorBrush,COLOR_BTNSHADOW
			invoke FrameRect,ps.hdc,addr rect,eax
		.endif
	.else
		; Is a flat button ?
		test [ebx].STRUCT_BUTTONEX.States,BTNEXS_FLAT
		.if !zero?
			; Is mouse over the button ?
			test [ebx].STRUCT_BUTTONEX.States,BTNEXS_MOUSEONBTN
			.if !zero?
				; Draw border ?
				test [ebx].STRUCT_BUTTONEX.States,BTNEXS_BORDER
				.if !zero?
					invoke DrawBorder,hWnd,ps.hdc,addr rect
				.endif
			.endif
		.else
			mov hWhitePen,$invoke(CreatePen,PS_SOLID,0,$invoke(GetSysColor,COLOR_BTNHILIGHT))
			mov hLtGrayPen,$invoke(CreatePen,PS_SOLID,0,$invoke(GetSysColor,COLOR_3DLIGHT))
			mov hDrGrayPen,$invoke(CreatePen,PS_SOLID,0,$invoke(GetSysColor,COLOR_BTNSHADOW))
			mov hBlackPen,$invoke(CreatePen,PS_SOLID,0,$invoke(GetSysColor,COLOR_3DDKSHADOW))
			
			; Draw top-left borders
			; White line
			mov hOldPen,$invoke(SelectObject,ps.hdc,hWhitePen)
			mov ebx,rect.bottom
			dec ebx
			invoke MoveToEx,ps.hdc,rect.left,ebx,NULL
			invoke LineTo,ps.hdc,rect.left, rect.top
			invoke LineTo,ps.hdc,rect.right, rect.top
		
			; Light gray line
			invoke SelectObject,ps.hdc,hLtGrayPen
			mov esi,rect.left
			inc esi
			mov edi,rect.top
			inc edi
			invoke MoveToEx,ps.hdc,esi,ebx,NULL
			invoke LineTo,ps.hdc,esi,edi
			invoke LineTo,ps.hdc,rect.right,edi
		
			; Draw bottom-right borders
			; Black line
			invoke SelectObject,ps.hdc,hBlackPen
			invoke MoveToEx,ps.hdc,rect.left,ebx,NULL
			mov esi,rect.right
			dec esi
			invoke LineTo,ps.hdc,esi,ebx
			mov edx,rect.top
			dec edx
			invoke LineTo,ps.hdc,esi,edx
	
			; Dark gray line
			invoke SelectObject,ps.hdc,hDrGrayPen
			mov edx,rect.left
			inc edx
			dec ebx
			invoke MoveToEx,ps.hdc,edx,ebx,NULL
			dec esi
			invoke LineTo,ps.hdc,esi,ebx
			invoke LineTo,ps.hdc,esi,rect.top
		
			invoke SelectObject,ps.hdc,hOldPen
										
			invoke DeleteObject,hWhitePen
			invoke DeleteObject,hLtGrayPen
			invoke DeleteObject,hDrGrayPen
		  	invoke DeleteObject,hBlackPen 
		.endif
	.endif
	
	mov ebx,pData
	
	lea eax,[ebx].STRUCT_BUTTONEX.szTitle
	mov lpTitle,eax
	mov lenTitle,$invoke(lstrlen,lpTitle)
	invoke CopyRect,addr captionRect,addr [ebx].STRUCT_BUTTONEX.rcRect
	
	; Draw the icon
	.if [ebx].STRUCT_BUTTONEX.IconStructIn.hIcon
		; Is button pressed ?
		mov ecx,BTNEXS_PRESSED
		and ecx,[ebx].STRUCT_BUTTONEX.States		; Test BTNEXS_PRESSED
		
		; Is button disabled ?		Show disabled image ?
		mov eax,BTNEXS_DISABLED
		and eax,[ebx].STRUCT_BUTTONEX.States		; Test BTNEXS_DISABLED+BTNEXS_DISABLEDIMAGE
		.if eax
			mov eax,BTNEXS_DISABLEDIMAGE
			and eax,[ebx].STRUCT_BUTTONEX.States
		.endif
		invoke DrawTheIcon,hWnd,ps.hdc,lenTitle,addr [ebx].STRUCT_BUTTONEX.rcRect,addr captionRect,ecx,eax
	.endif

	; Draw the bitmap
	.if [ebx].STRUCT_BUTTONEX.BitmapStructIn.hBitmap
		invoke SetBkColor,ps.hdc,00FFFFFFh ; White color
		; Is button pressed ?
		mov ecx,BTNEXS_PRESSED
		and ecx,[ebx].STRUCT_BUTTONEX.States		; Test BTNEXS_PRESSED
		
		; Is button disabled ?		Show disabled image ?
		mov eax,BTNEXS_DISABLED
		and eax,[ebx].STRUCT_BUTTONEX.States		; Test BTNEXS_DISABLED+BTNEXS_DISABLEDIMAGE
		.if eax
			mov eax,BTNEXS_DISABLEDIMAGE
			and eax,[ebx].STRUCT_BUTTONEX.States
		.endif
		invoke DrawTheBitmap,hWnd,ps.hdc,lenTitle,addr [ebx].STRUCT_BUTTONEX.rcRect,addr captionRect,ecx,eax
	.endif

	; Write the button title
	.if lenTitle
		; Select the font
		invoke SelectObject,ps.hdc,[ebx].STRUCT_BUTTONEX.hDefaultFont
		push eax
		
		; Draw the button's title
		; If button is pressed then "press" title also
		; Is button pressed ?
		test [ebx].STRUCT_BUTTONEX.States,BTNEXS_PRESSED
		.if !zero?
			invoke OffsetRect,addr captionRect,[ebx].STRUCT_BUTTONEX.ptPressedOffset.x,[ebx].STRUCT_BUTTONEX.ptPressedOffset.y
		.endif
		
		invoke CopyRect,addr centerRect,addr captionRect
		invoke DrawText,ps.hdc,lpTitle,-1,addr captionRect,DT_WORDBREAK or DT_CENTER or DT_CALCRECT
		
		; HCenter text
		mov ecx,captionRect.right
		.if centerRect.right>ecx
			mov ecx,centerRect.right
			sub ecx,centerRect.left
					
			mov edx,captionRect.right
			sub edx,captionRect.left
			
			sub ecx,edx
			shr ecx,1
			
			add captionRect.left,ecx
			add captionRect.right,ecx
		.else
			mov ecx,centerRect.left
			mov captionRect.left,ecx
		.endif
		
		; VCenter text
		mov ecx,centerRect.bottom
		sub ecx,centerRect.top
		.if eax<ecx
			sub ecx,eax
			shr ecx,1
			
			mov edx,centerRect.top
			add edx,ecx
			mov captionRect.top,edx
			mov ecx,captionRect.top
			add ecx,eax
			mov captionRect.bottom,ecx
		.endif
		
		invoke SetBkMode,ps.hdc,TRANSPARENT
			
		mov ebx,pData
		; Is button disabled ?
		test [ebx].STRUCT_BUTTONEX.States,BTNEXS_DISABLED
		.if !zero?
			invoke OffsetRect,addr captionRect,1,1
			invoke SetTextColor,ps.hdc,$invoke(GetSysColor,COLOR_3DHILIGHT)
			invoke DrawText,ps.hdc,lpTitle,-1,addr captionRect,DT_WORDBREAK or DT_CENTER
			invoke OffsetRect,addr captionRect,-1,-1
			invoke SetTextColor,ps.hdc,$invoke(GetSysColor,COLOR_3DSHADOW)
			invoke DrawText,ps.hdc,lpTitle,-1,addr captionRect,DT_WORDBREAK or DT_CENTER
		.else
			; Is mouse over the button ?
			mov ecx,BTNEXS_MOUSEONBTN
			and ecx,[ebx].STRUCT_BUTTONEX.States		; Test BTNEXS_MOUSEONBTN
		
			; Is button pressed ?
			mov edx,BTNEXS_PRESSED
			and edx,[ebx].STRUCT_BUTTONEX.States		; Test BTNEXS_PRESSED
			.if(ecx || edx)
				invoke SetTextColor,ps.hdc,[ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_FG_IN]
				invoke SetBkColor,ps.hdc,[ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_BK_IN]
			.else
				invoke SetTextColor,ps.hdc,[ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_FG_OUT]
				invoke SetBkColor,ps.hdc,[ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_BK_OUT]
			.endif
			invoke DrawText,ps.hdc,lpTitle,-1,addr captionRect,DT_WORDBREAK or DT_CENTER
		.endif
		
		; Restore font
		pop eax
		invoke SelectObject,ps.hdc,eax
	.endif
	
	; Is a flat button ?
	mov ecx,BTNEXS_FLAT
	and ecx,[ebx].STRUCT_BUTTONEX.States		; Test BTNEXS_FLAT

	; Draw focus rectangle for flat button ?
	mov edx,BTNEXS_FLATFOCUS
	and edx,[ebx].STRUCT_BUTTONEX.States		; Test BTNEXS_FLATFOCUS
	
	.if(!ecx || (ecx && edx))
		; Is button focused ?
		test [ebx].STRUCT_BUTTONEX.States,BTNEXS_FOCUSED
		.if !zero?
			invoke CopyRect,addr focusRect,addr rect
			invoke InflateRect,addr focusRect,-3,-3
			invoke CreateSolidBrush,0
			invoke SetTextColor,ps.hdc,00000000h
			invoke DrawFocusRect,ps.hdc,addr focusRect
		.endif
	.endif
	
	invoke EndPaint,hWnd,addr ps
	ret
PaintButton endp

PrepareImageRect proc uses ebx esi hWnd:HWND,bHasTitle:DWORD,pRectItem:DWORD,pRectTitle:DWORD,bIsPressed:BOOL,nWidth:DWORD,nHeight:DWORD,pImage:DWORD
	LOCAL rcBtn:RECT
	
	invoke CopyRect,pImage,pRectItem
	mov ebx,pImage
	
	invoke GetWindowLong,hWnd,0
	mov esi,eax
	
	mov eax,BTNEXS_ALIGN
	and eax,[esi].STRUCT_BUTTONEX.States		; Test BTNEXS_ALIGN
	
	assume ebx:ptr RECT
	.if eax==BTNEXST_ALIGN_HORIZ
			.if !bHasTitle
				; Center image horizontally
				mov eax,[ebx].right
				sub eax,[ebx].left
				sub eax,nWidth
				shr eax,1
				add [ebx].left,eax
			.else
				; Image must be placed just inside the focus rect
				mov ecx,3
				add [ebx].left,ecx
				add ecx,nWidth
				mov eax,pRectTitle
				add [eax].RECT.left,ecx
			.endif
			
			;Center image vertically
			mov eax,[ebx].bottom
			sub eax,[ebx].top
			sub eax,nHeight
			shr eax,1
			add [ebx].RECT.top,eax
			
	.elseif eax==BTNEXST_ALIGN_HORIZ_RIGHT
			invoke GetClientRect,hWnd,addr rcBtn
			.if !bHasTitle
				; Center image horizontally
				mov eax,[ebx].right
				sub eax,[ebx].left
				sub eax,nWidth
				shr eax,1
				add [ebx].left,eax
			.else
				; Image must be placed just inside the focus rect
				mov eax,pRectTitle
				assume eax:ptr RECT
				mov edx,[eax].right
				sub edx,[eax].left
				sub edx,nWidth
				sub edx,3
				mov [eax].right,edx
				mov [eax].left,3
				mov edx,rcBtn.right
				sub edx,nWidth
				sub edx,3
				mov [ebx].left,edx
				assume eax:nothing
				
				; Center image vertically
				mov eax,[ebx].bottom
				sub eax,[ebx].top
				sub eax,nHeight
				shr eax,1
				add [ebx].top,eax
			.endif
	
	.elseif eax==BTNEXST_ALIGN_VERT
			; Center image horizontally
			mov eax,[ebx].right
			sub eax,[ebx].left
			sub eax,nWidth
			shr eax,1
			add [ebx].left,eax
			.if !bHasTitle
				; Center image vertically
				mov eax,[ebx].bottom
				sub eax,[ebx].top
				sub eax,nHeight
				shr eax,1
				add [ebx].top,eax
			.else
				mov [ebx].top,3
				mov eax,pRectTitle
				mov ecx,nHeight
				add [eax].RECT.top,ecx
			.endif
	.endif
	assume ebx:nothing
	
	; If button is pressed then press image also
	.if bIsPressed
		invoke OffsetRect,pImage,\
			[esi].STRUCT_BUTTONEX.ptPressedOffset.x,[esi].STRUCT_BUTTONEX.ptPressedOffset.y
	.endif
	ret
PrepareImageRect endp

DrawTheIcon proc uses ebx  hWnd:HWND,hdc:HDC,bHasTitle:DWORD,pRectItem:DWORD,pRectTitle:DWORD,bIsPressed:BOOL,bIsDisabled:BOOL
	LOCAL rcImage		:RECT
	
	invoke GetWindowLong,hWnd,0

	; Is the button a checkbox ?
	mov edx,BTNEXS_CHECKBOX
	and edx,[eax].STRUCT_BUTTONEX.States	; Test BTNEXS_CHECKBOX
	
	; Is mouse over the button ?
	mov ecx,BTNEXS_MOUSEONBTN
	and ecx,[eax].STRUCT_BUTTONEX.States	; Test BTNEXS_MOUSEONBTN
	
	; Select the icon to use
	.if((edx && bIsPressed) || (!edx && (bIsPressed || ecx)))
		lea ebx,[eax].STRUCT_BUTTONEX.IconStructIn 
	.else
		mov ebx,[eax].STRUCT_BUTTONEX.IconStructOut.hIcon
		.if ebx != 0
			lea ebx,[eax].STRUCT_BUTTONEX.IconStructOut
		.else
			lea ebx,[eax].STRUCT_BUTTONEX.IconStructIn
		.endif
	.endif
	
	assume ebx:ptr STRUCT_ICONS
	invoke PrepareImageRect,hWnd,bHasTitle,pRectItem,pRectTitle,bIsPressed,
					[ebx].dwWidth,[ebx].dwHeight,addr rcImage
			
	.if bIsDisabled
		invoke DrawState,hdc,NULL,NULL,[ebx].hIcon,0,rcImage.left,rcImage.top,
					[ebx].dwWidth,[ebx].dwHeight,DSS_DISABLED or DST_ICON
	.else
		invoke DrawState,hdc,NULL,NULL,[ebx].hIcon,0,rcImage.left,rcImage.top,
					[ebx].dwWidth,[ebx].dwHeight,DSS_NORMAL or DST_ICON
	.endif	
	assume ebx:nothing
	ret
DrawTheIcon endp

DrawTheBitmap proc uses ebx hWnd:HWND,hdc:HDC,bHasTitle:DWORD,pRectItem:DWORD,pRectTitle:DWORD,bIsPressed:BOOL,bIsDisabled:BOOL
	LOCAL hdcBmpMem				:HDC
	LOCAL hdcMem				:HDC
	LOCAL hDC					:HDC
	LOCAL hbmOldBmp				:HBITMAP
	LOCAL hbmT					:HBITMAP
	LOCAL hBitmap				:HBITMAP
	LOCAL hOldBmp2				:HBITMAP
	LOCAL byIndex				:BYTE
	LOCAL rcImage				:RECT
	LOCAL rcRect				:RECT
	LOCAL crOldColor			:COLORREF
	
	invoke GetWindowLong,hWnd,0

	; Is the button a checkbox ?
	mov edx,BTNEXS_CHECKBOX
	and edx,[eax].STRUCT_BUTTONEX.States		; Test BTNEXS_CHECKBOX
	
	; Is mouse over the button ?
	mov ecx,BTNEXS_MOUSEONBTN
	and ecx,[eax].STRUCT_BUTTONEX.States		; Test BTNEXS_MOUSEONBTN
	
	; Select the bitmap to use
	.if ((edx && bIsPressed) || (!edx && (bIsPressed || ecx)))
		lea ebx,[eax].STRUCT_BUTTONEX.BitmapStructIn
	.else
		mov ebx,[eax].STRUCT_BUTTONEX.BitmapStructOut.hBitmap
		.if ebx != 0
			lea ebx,[eax].STRUCT_BUTTONEX.BitmapStructOut
		.else
			lea ebx,[eax].STRUCT_BUTTONEX.BitmapStructIn
		.endif
	.endif

	assume ebx:ptr STRUCT_BITMAPS
	invoke PrepareImageRect,hWnd,bHasTitle,pRectItem,pRectTitle,bIsPressed,
					[ebx].dwWidth,[ebx].dwHeight,addr rcImage

	mov hdcBmpMem,$invoke(CreateCompatibleDC,hdc)
	mov hbmOldBmp,$invoke(SelectObject,hdcBmpMem,[ebx].hBitmap)
	mov hdcMem,$invoke(CreateCompatibleDC,NULL)
	mov hbmT,$invoke(SelectObject,hdcMem,[ebx].hMask)

	.if bIsDisabled ;&& bShowDisabledBitmap)
		mov hDC,$invoke(CreateCompatibleDC,hdc)
		mov hBitmap,$invoke(CreateCompatibleBitmap,hdc,[ebx].dwWidth,[ebx].dwHeight)
		mov hOldBmp2,$invoke(SelectObject,hDC, hBitmap)
		
		invoke SetRect,addr rcRect,0,0,rcImage.right,rcImage.bottom
		inc rcRect.right
		inc rcRect.bottom
		
		invoke FillRect,hDC,addr rcRect,$invoke(CreateSolidBrush,00FFFFFFh)
		mov crOldColor,$invoke(SetBkColor,hDC,00FFFFFFh)

		invoke BitBlt,hDC,0,0,[ebx].dwWidth,[ebx].dwHeight,hdcMem,0,0,SRCAND
		invoke BitBlt,hDC,0,0,[ebx].dwWidth,[ebx].dwHeight,hdcBmpMem,0,0,SRCPAINT
		
		invoke SetBkColor,hDC,crOldColor
		invoke SelectObject,hDC,hOldBmp2
		invoke DeleteDC,hDC

		invoke DrawState,hdc,NULL,NULL,hBitmap,0,rcImage.left,rcImage.top,
						[ebx].dwWidth,[ebx].dwHeight,DST_BITMAP or DSS_DISABLED
		invoke DeleteObject,hBitmap
	.else
		invoke BitBlt,hdc,rcImage.left,rcImage.top,[ebx].dwWidth,[ebx].dwHeight,hdcMem,0,0,SRCAND
		invoke BitBlt,hdc,rcImage.left,rcImage.top,[ebx].dwWidth,[ebx].dwHeight,hdcBmpMem,0,0,SRCPAINT
	.endif
	assume ebx:nothing
	
	invoke SelectObject,hdcMem,hbmT
	invoke DeleteDC,hdcMem

	invoke SelectObject,hdcBmpMem,hbmOldBmp
	invoke DeleteDC,hdcBmpMem
	ret
DrawTheBitmap endp 

PaintBk	proc uses ebx hWnd:HWND,hdc:HDC
	LOCAL clDC			:HDC
	LOCAL rect			:RECT
	LOCAL rect1			:RECT
	LOCAL hParentWnd	:HWND
	
	invoke GetWindowLong,hWnd,0
	mov ebx,eax
	invoke GetParent,hWnd
	mov hParentWnd,eax
	mov clDC,$invoke(GetDC,hParentWnd)
	invoke GetClientRect,hWnd,addr rect
	invoke GetWindowRect,hWnd,addr rect1
	invoke ScreenToClient,hParentWnd,addr rect1
	invoke ScreenToClient,hParentWnd,addr rect1.right

	.if ![ebx].STRUCT_BUTTONEX.dcBk
		mov [ebx].STRUCT_BUTTONEX.dcBk,$invoke(CreateCompatibleDC,clDC)
		mov [ebx].STRUCT_BUTTONEX.bmpBk,$invoke(CreateCompatibleBitmap,clDC,rect.right,rect.bottom)
		mov [ebx].STRUCT_BUTTONEX.pbmpOldBk,$invoke(SelectObject,[ebx].STRUCT_BUTTONEX.dcBk,[ebx].STRUCT_BUTTONEX.bmpBk)
		invoke BitBlt,[ebx].STRUCT_BUTTONEX.dcBk,0,0,rect.right,rect.bottom,clDC,rect1.left,rect1.top,SRCCOPY
	.endif
	invoke BitBlt,hdc,0,0,rect.right,rect.bottom,[ebx].STRUCT_BUTTONEX.dcBk,0,0,SRCCOPY		
	invoke ReleaseDC,hParentWnd,clDC
	ret
PaintBk	endp

DrawBackground proc uses ebx hWnd:HWND,hdc:HDC,pRect:DWORD
	LOCAL 	state:DWORD
	
	invoke GetWindowLong,hWnd,0
	mov ebx,eax
	
	test [ebx].STRUCT_BUTTONEX.States,BTNEXS_USETHEME
	jz @F
	mov state,BTNEX_THEME_NORMAL
	
	; Is default ?
	test [ebx].STRUCT_BUTTONEX.States,BTNEXS_DEFAULT
	.if !zero?
		mov state,BTNEX_THEME_DEFAULTED
	.endif
	
	; Is mouse on button ?
	test [ebx].STRUCT_BUTTONEX.States,BTNEXS_MOUSEONBTN
	.if !zero?
		mov state,BTNEX_THEME_HOT
	.endif
	
	; Is pressed ?
	test [ebx].STRUCT_BUTTONEX.States,BTNEXS_PRESSED
	.if !zero?
		mov state,BTNEX_THEME_PRESSED
	.endif
	
	; Is disabled ?
	test [ebx].STRUCT_BUTTONEX.States,BTNEXS_DISABLED
	.if !zero?
		mov state,BTNEX_THEME_DISABLED
	.endif
	
	mov eax,pRect
	inc [eax].RECT.bottom
	inc [eax].RECT.right
	
	invoke GetProcAddress,g_hThemeDll,offset szDrawThemeParentBackground
	push pRect;NULL
	push hdc
	push hWnd
	call eax
	
	invoke GetProcAddress,g_hThemeDll,offset szDrawThemeBackground
	push NULL
	push pRect
	push state
	push BP_PUSHBUTTON
	push hdc
	push g_hTheme
	call eax
	ret
@@:
	; Is mouse on button ?
	mov ecx,BTNEXS_MOUSEONBTN
	and ecx,[ebx].STRUCT_BUTTONEX.States		; Test BTNEXS_MOUSEONBTN

	; Is pressed ?
	mov edx,BTNEXS_PRESSED
	and edx,[ebx].STRUCT_BUTTONEX.States		; Test BTNEXS_PRESSED
	
	.if(ecx || edx)	; Mouse on button or pressed
		mov eax, [ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_BK_IN]
	.else
		; Is button focused ?
		test [ebx].STRUCT_BUTTONEX.States,BTNEXS_FOCUSED
		.if !zero? 	
			mov eax,[ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_BK_FOCUS]
		.else
			mov eax,[ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_BK_OUT]
		.endif
	.endif
	invoke CreateSolidBrush,eax
	invoke FillRect,hdc,pRect,eax
	ret
DrawBackground endp

DrawBorder proc uses ebx esi edi  hWnd:HWND,hdc:HDC,pRect:DWORD
	LOCAL nWidth			:DWORD
	LOCAL nHeight			:DWORD
	LOCAL x					:DWORD
	LOCAL y					:DWORD
	LOCAL clrTopLeft		:DWORD
	LOCAL clrBottomRight	:DWORD
	
	invoke GetWindowLong,hWnd,0

	;Is pressed ?
	test [eax].STRUCT_BUTTONEX.States,BTNEXS_PRESSED
	.if !zero?
		mov clrTopLeft,$invoke(GetSysColor,COLOR_BTNSHADOW)
		mov clrBottomRight,$invoke(GetSysColor,COLOR_BTNHILIGHT)
	.else
		mov clrTopLeft,$invoke(GetSysColor,COLOR_BTNHILIGHT)
		mov clrBottomRight,$invoke(GetSysColor,COLOR_BTNSHADOW)
	.endif
	
	mov ebx,pRect
	assume ebx:ptr RECT
	mov eax,[ebx].left
	mov ecx,[ebx].top
	mov esi,[ebx].right
	sub esi,eax
	mov edi,[ebx].bottom
	assume ebx:nothing
	sub edi,ecx
	mov x,eax
	mov y,ecx
	mov nWidth,esi
	mov nHeight,edi
	
	dec esi
	invoke FillSolidRect,hdc,x,y,esi,1,clrTopLeft
	dec edi

	invoke FillSolidRect,hdc,x,y,1,edi,clrTopLeft
	inc edi
	inc esi
	add esi,x
	invoke FillSolidRect,hdc,esi,y,-1,edi,clrBottomRight
	add y,edi
	invoke FillSolidRect,hdc,x,y,nWidth,-1,clrBottomRight
	ret
DrawBorder endp

FillSolidRect proc hdc:HDC,x:DWORD,y:DWORD,nWidth:DWORD,nHeight:DWORD,clr:COLORREF
	LOCAL rect:RECT
	
	invoke SetBkColor,hdc,clr
	mov eax,nWidth
	mov ecx,nHeight
	add eax,x
	add ecx,y
	invoke SetRect,addr rect,x,y,eax,ecx
	invoke ExtTextOut,hdc,0,0,ETO_OPAQUE,addr rect,NULL,0,NULL
	ret
FillSolidRect endp

SetDefaultColors proc uses ebx hWnd:HWND
	invoke GetWindowLong,hWnd,0
	mov ebx,eax
	mov [ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_BK_IN],$invoke(GetSysColor,COLOR_3DFACE)
	mov [ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_FG_IN],$invoke(GetSysColor,COLOR_BTNTEXT)	
	mov [ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_BK_OUT],$invoke(GetSysColor,COLOR_3DFACE)	
	mov [ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_FG_OUT],$invoke(GetSysColor,COLOR_BTNTEXT)
	mov [ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_BK_FOCUS],$invoke(GetSysColor,COLOR_3DFACE)
	mov [ebx].STRUCT_BUTTONEX.crColors[BTNEXST_COLOR_FG_FOCUS],$invoke(GetSysColor,COLOR_BTNTEXT)
	ret
SetDefaultColors endp

SetColor proc hWnd:HWND,byColorIndex:BYTE,crColor:COLORREF
	; Set new color
	invoke GetWindowLong,hWnd,0
	mov edx,crColor
	movzx ecx,byColorIndex
	mov [eax].STRUCT_BUTTONEX.crColors[ecx],edx
	invoke InvalidateRect,hWnd,NULL,TRUE
	ret
SetColor endp

SetSound proc hWnd:HWND,nSoundHoverID:DWORD,nSoundClickID:BOOL
	invoke GetWindowLong,hWnd,0
	push nSoundHoverID
	pop [eax].STRUCT_BUTTONEX.SoundStructOver.nSoundID
	push nSoundClickID
	pop [eax].STRUCT_BUTTONEX.SoundStructClick.nSoundID
	ret
SetSound endp

SetIcon proc uses ebx hWnd:HWND,nIconInID:DWORD,nIconOutID:DWORD
	LOCAL	bRetValue	:BOOL
	LOCAL	ii			:ICONINFO
	LOCAL	hIconIn		:HICON
	LOCAL	hIconOut	:HICON
	
	invoke GetWindowLong,hWnd,0
	mov	ebx,eax
	
	; Load icon when the mouse is IN the button
	mov hIconIn,$invoke(LoadImage,g_hInstance,nIconInID,IMAGE_ICON,0,0,0)
	
  	; Load icon when the mouse is OUT the button
	.if nIconOutID
		mov hIconOut,$invoke(LoadImage,g_hInstance,nIconOutID,IMAGE_ICON,0,0,0)
	.else
		mov hIconOut,NULL
	.endif
	
	invoke FreeResources,hWnd
	.if hIconIn
		; Icon when mouse over button
		mov eax,hIconIn
		mov [ebx].STRUCT_BUTTONEX.IconStructIn.hIcon,eax
		
		; Get icon dimension
		invoke ZeroMemory,addr ii,sizeof ICONINFO
		
		mov bRetValue,$invoke(GetIconInfo,hIconIn,addr ii)
		
		.if !bRetValue
			invoke FreeResources,hWnd
			ret
		.endif
	
		mov eax,ii.xHotspot
		mov ecx,ii.yHotspot
		shl eax,1
		shl ecx,1
		mov [ebx].STRUCT_BUTTONEX.IconStructIn.dwWidth,eax
		mov [ebx].STRUCT_BUTTONEX.IconStructIn.dwHeight,ecx
	
		invoke DeleteObject,ii.hbmMask
		invoke DeleteObject,ii.hbmColor
	
		; Icon when mouse outside button?
		.if !hIconOut
			mov hIconOut,$invoke(CreateGrayscaleIcon,hWnd,hIconIn)
		.endif
		
		mov eax,hIconOut
		mov [ebx].STRUCT_BUTTONEX.IconStructOut.hIcon,eax
		
		; Get icon dimension
		invoke ZeroMemory,addr ii,sizeof ICONINFO
		
		mov bRetValue,$invoke(GetIconInfo,hIconOut,addr ii)
		.if !bRetValue
			invoke FreeResources,hWnd
			ret
		.endif
		
		mov eax,ii.xHotspot
		mov ecx,ii.yHotspot
		shl eax,1
		shl ecx,1
		mov [ebx].STRUCT_BUTTONEX.IconStructOut.dwWidth,eax
		mov [ebx].STRUCT_BUTTONEX.IconStructOut.dwHeight,ecx
		
		invoke DeleteObject,ii.hbmMask
		invoke DeleteObject,ii.hbmColor
	.endif
	invoke InvalidateRect,hWnd,NULL,TRUE
	ret
SetIcon endp

SetBitmap proc uses ebx hWnd:HWND,nBitmapInID:DWORD,nBitmapOutID:DWORD
	LOCAL	nRetValue		:DWORD
	LOCAL	csBitmapSize	:BITMAP
	LOCAL	hBitmapIn		:HBITMAP
	LOCAL	hBitmapOut		:HBITMAP
	
	invoke GetWindowLong,hWnd,0
	mov	ebx,eax
		
	; Load bitmap when the mouse is IN the button
	invoke LoadImage,g_hInstance,nBitmapInID,IMAGE_BITMAP,0,0,0
	mov hBitmapIn,eax
	
	; Load bitmap when the mouse is OUT the button
	.if nBitmapOutID
		invoke LoadImage,g_hInstance,nBitmapOutID,IMAGE_BITMAP,0,0,0
		mov hBitmapOut,eax
	.endif
	
	invoke FreeResources,hWnd
	.if hBitmapIn
		mov eax,hBitmapIn
		mov [ebx].STRUCT_BUTTONEX.BitmapStructIn.hBitmap,eax
		
		; Get bitmap size
		mov nRetValue,$invoke(GetObject,hBitmapIn,sizeof BITMAP,addr csBitmapSize)
		
		.if !nRetValue
			invoke FreeResources,hWnd
			ret
		.endif
		
		mov eax,csBitmapSize.bmWidth
		mov [ebx].STRUCT_BUTTONEX.BitmapStructIn.dwWidth,eax
		mov ecx,csBitmapSize.bmHeight
		mov [ebx].STRUCT_BUTTONEX.BitmapStructIn.dwHeight,ecx
	
		; Create mask for bitmap In
		mov [ebx].STRUCT_BUTTONEX.BitmapStructIn.hMask,$invoke(CreateBitmapMask,hBitmapIn,eax,ecx) 
		.if ![ebx].STRUCT_BUTTONEX.BitmapStructIn.hMask
			invoke FreeResources,hWnd
			ret
		.endif
	
		.if hBitmapOut
			mov eax,hBitmapOut
			mov [ebx].STRUCT_BUTTONEX.BitmapStructOut.hBitmap,eax
			
			; Get bitmap size
			mov nRetValue,$invoke(GetObject,hBitmapOut,sizeof BITMAP,addr csBitmapSize)
			
			.if !nRetValue
				invoke FreeResources,hWnd
				ret
			.endif
			
			mov eax,csBitmapSize.bmWidth
			mov [ebx].STRUCT_BUTTONEX.BitmapStructOut.dwWidth,eax
			mov ecx,csBitmapSize.bmHeight
			mov [ebx].STRUCT_BUTTONEX.BitmapStructOut.dwHeight,ecx
			
			; Create mask for bitmap Out
			mov [ebx].STRUCT_BUTTONEX.BitmapStructOut.hMask,$invoke(CreateBitmapMask,hBitmapOut,eax,ecx)
			.if ![ebx].STRUCT_BUTTONEX.BitmapStructOut.hMask
				invoke FreeResources,hWnd
				ret
			.endif
		.endif
	.endif
	invoke InvalidateRect,hWnd,NULL,TRUE
	ret
SetBitmap endp

FreeResources proc uses ebx hWnd:HWND

	invoke GetWindowLong,hWnd,0
	mov	ebx,eax
	
	; Destroy cursor
	.if [ebx].STRUCT_BUTTONEX.hCursor
		invoke DestroyCursor,[ebx].STRUCT_BUTTONEX.hCursor
	.endif
	
	; Destroy icons
	.if [ebx].STRUCT_BUTTONEX.IconStructIn.hIcon
		invoke DestroyIcon,[ebx].STRUCT_BUTTONEX.IconStructIn.hIcon
	.endif
	.if [ebx].STRUCT_BUTTONEX.IconStructOut.hIcon
		invoke DestroyIcon,[ebx].STRUCT_BUTTONEX.IconStructOut.hIcon
	.endif
		
	; Destroy bitmaps
	.if [ebx].STRUCT_BUTTONEX.BitmapStructIn.hBitmap
		invoke DeleteObject,[ebx].STRUCT_BUTTONEX.BitmapStructIn.hBitmap
	.endif
	.if [ebx].STRUCT_BUTTONEX.BitmapStructOut.hBitmap
		invoke DeleteObject,[ebx].STRUCT_BUTTONEX.BitmapStructOut.hBitmap
	.endif

	; Destroy mask bitmaps
	.if [ebx].STRUCT_BUTTONEX.BitmapStructIn.hMask
		invoke DeleteObject,[ebx].STRUCT_BUTTONEX.BitmapStructIn.hMask
	.endif
	.if [ebx].STRUCT_BUTTONEX.BitmapStructOut.hMask	
		invoke DeleteObject,[ebx].STRUCT_BUTTONEX.BitmapStructOut.hMask
	.endif

	invoke ZeroMemory,addr [ebx].STRUCT_BUTTONEX.IconStructIn, sizeof STRUCT_ICONS
	invoke ZeroMemory,addr [ebx].STRUCT_BUTTONEX.IconStructOut, sizeof STRUCT_ICONS
	invoke ZeroMemory,addr [ebx].STRUCT_BUTTONEX.BitmapStructIn, sizeof STRUCT_BITMAPS
	invoke ZeroMemory,addr [ebx].STRUCT_BUTTONEX.BitmapStructOut, sizeof STRUCT_BITMAPS
	ret
FreeResources endp

CreateGrayscaleIcon proc uses ebx esi edi  hWnd:HWND,hIcon:HICON
	LOCAL	hGrayIcon	:HICON
	LOCAL	hMainDC		:HDC
	LOCAL	hMemDC1		:HDC
	LOCAL	hMemDC2		:HDC			
	LOCAL	bmp			:BITMAP
	LOCAL	hOldBmp1	:HBITMAP 
	LOCAL	hOldBmp2	:HBITMAP
	LOCAL	csII		:ICONINFO 
	LOCAL	csGrayII	:ICONINFO
	LOCAL	bRetValue	:BOOL
	LOCAL	dwLoopY		:DWORD
	LOCAL   dwLoopX		:DWORD
	LOCAL	dwLoopToY	:DWORD
	LOCAL   dwLoopToX	:DWORD

	mov bRetValue,$invoke(GetIconInfo,hIcon,addr csII)	
	.if !bRetValue
		mov eax,NULL
		ret
	.endif
	
	mov hMainDC,$invoke(GetDC,hWnd) 
	mov hMemDC1,$invoke(CreateCompatibleDC,hMainDC)
	mov hMemDC2,$invoke(CreateCompatibleDC,hMainDC)
	
	.if(hMainDC == NULL || hMemDC1 == NULL || hMemDC2 == NULL)	
		mov eax,NULL
		ret
  	.endif
  	
  	invoke GetObject,csII.hbmColor,sizeof BITMAP,addr bmp
	.if eax
		mov eax,csII.xHotspot
		mov ebx,csII.yHotspot
		shl eax,1
		shl ebx,1
		movzx ecx,bmp.bmPlanes
		movzx edx,bmp.bmBitsPixel
		
		mov csGrayII.hbmColor,$invoke(CreateBitmap,eax,ebx,ecx,edx,NULL)
		.if csGrayII.hbmColor
			mov hOldBmp1,$invoke(SelectObject,hMemDC1,csII.hbmColor)
			mov hOldBmp2,$invoke(SelectObject,hMemDC2,csGrayII.hbmColor)
			mov eax,csII.xHotspot
			mov ebx,csII.yHotspot
			shl eax,1
			shl ebx,1
			invoke BitBlt,hMemDC2,0,0,eax,ebx,hMemDC1,0,0,SRCCOPY
			
			mov eax,csII.xHotspot
			shl eax,1
			mov dwLoopToX,eax
			
			mov dwLoopY,0
			mov eax,csII.yHotspot
			shl eax,1
			mov dwLoopToY,eax
				
			.while TRUE
				mov eax,dwLoopToY
				.break .if (dwLoopY == eax)
				mov dwLoopX,0
				.while TRUE
					mov eax,dwLoopToX
					.break .if (dwLoopX == eax)
					
					invoke GetPixel,hMemDC2,dwLoopX,dwLoopY

					movzx ebx,al	; ebx-R	
					movzx esi,ax 
					shr esi,8		; esi-G
					mov edi,eax
					shr edi,16		; edi-B
					
					mov eax,299
					mul ebx
					mov ebx,eax		; Result in ebx
					mov eax,587
					mul esi
					add ebx,eax
					mov eax,114
					mul edi
					add eax,ebx
					mov ebx,1000
					div ebx
					
					.if eax
						mov bl,al
						mov bh,al
						shl ebx,8
						mov bl,al
						invoke SetPixel,hMemDC2,dwLoopX,dwLoopY,ebx
					.endif
					inc dwLoopX
				.endw
				inc dwLoopY
			.endw

			invoke SelectObject,hMemDC1,hOldBmp1
			invoke SelectObject,hMemDC2,hOldBmp2

			mov eax,csII.hbmMask
			mov csGrayII.hbmMask,eax			
			mov csGrayII.fIcon,TRUE
			mov hGrayIcon,$invoke(CreateIconIndirect,addr csGrayII)
		.endif
		invoke DeleteObject,csGrayII.hbmColor
	.endif

	invoke DeleteObject,csII.hbmColor
	invoke DeleteObject,csII.hbmMask
	invoke DeleteDC,hMemDC1
	invoke DeleteDC,hMemDC2
	invoke ReleaseDC,hWnd,hMainDC
	mov eax,hGrayIcon;
	ret
CreateGrayscaleIcon endp

CreateBitmapMask proc hSourceBitmap:HBITMAP,dwWidth:DWORD,dwHeight:DWORD
	LOCAL	hMask			:HBITMAP
	LOCAL	hdcSrc			:HDC
	LOCAL	hdcDest			:HDC
	LOCAL	hbmSrcT			:HBITMAP
	LOCAL	hbmDestT		:HBITMAP
	LOCAL	crSaveBk		:COLORREF
	LOCAL	crSaveDestText	:COLORREF
	LOCAL	crTransColor	:COLORREF
	
	mov hMask,$invoke(CreateBitmap,dwWidth,dwHeight,1,1,NULL)	
	.if !hMask
		mov eax,NULL
		ret
	.endif

	mov hdcSrc,$invoke(CreateCompatibleDC,NULL)
	mov hdcDest,$invoke(CreateCompatibleDC,NULL)
	mov hbmSrcT,$invoke(SelectObject,hdcSrc,hSourceBitmap)
	mov hbmDestT,$invoke(SelectObject,hdcDest,hMask)
	mov crTransColor,$invoke(GetPixel,hdcSrc,0,0)
	mov crSaveBk,$invoke(SetBkColor,hdcSrc,crTransColor)

	invoke BitBlt,hdcDest,0,0,dwWidth,dwHeight,hdcSrc,0,0,SRCCOPY
	mov crSaveDestText,$invoke(SetTextColor,hdcSrc,00FFFFFFh)
	invoke SetBkColor,hdcSrc,00000000h
	invoke BitBlt,hdcSrc,0,0,dwWidth,dwHeight,hdcDest,0,0,SRCAND
	invoke SetTextColor,hdcDest,crSaveDestText
	invoke SetBkColor,hdcSrc,crSaveBk
	invoke SelectObject,hdcSrc,hbmSrcT
	invoke SelectObject,hdcDest,hbmDestT
	invoke DeleteDC,hdcSrc
	invoke DeleteDC,hdcDest
	mov eax,hMask
	ret
CreateBitmapMask endp

CancelHover proc uses esi ebx hWnd:HWND
	LOCAL bMouseOnButton	:BOOL
	
	invoke GetWindowLong,hWnd,0
	mov esi,eax
	
	and [esi].STRUCT_BUTTONEX.States,-1 xor BTNEXS_PRESSED	; Clear BTNEXS_PRESSED
	
	; Is a flat button ?
	test [esi].STRUCT_BUTTONEX.States,BTNEXS_FLAT
	.if !zero?							
		test [esi].STRUCT_BUTTONEX.States,BTNEXS_MOUSEONBTN
		.if !zero?
			and [esi].STRUCT_BUTTONEX.States,-1 xor BTNEXS_MOUSEONBTN		; Clear BTNEXS_MOUSEONBTN
		.endif
	.endif
	invoke InvalidateRect,hWnd,NULL,TRUE
	ret
CancelHover endp

DrawTransparent proc uses ebx hWnd:HWND
	invoke GetWindowLong,hWnd,0
	mov ebx,eax
	or [ebx].STRUCT_BUTTONEX.States,BTNEXS_TRANSPARENT  ; Set BTNEXS_TRANSPARENT

	; Restore old bitmap (if any)
	.if ([ebx].STRUCT_BUTTONEX.dcBk && [ebx].STRUCT_BUTTONEX.pbmpOldBk)
		invoke SelectObject,[ebx].STRUCT_BUTTONEX.dcBk,[ebx].STRUCT_BUTTONEX.pbmpOldBk
	.endif

	invoke DeleteObject,[ebx].STRUCT_BUTTONEX.bmpBk
	invoke DeleteDC,[ebx].STRUCT_BUTTONEX.dcBk
	ret
DrawTransparent endp

OpenTheme proc hWnd:HWND
	LOCAL	bstrButton[8]:WORD
	
	invoke MultiByteToWideChar,CP_ACP,0,addr szButton,-1,addr bstrButton,8
	invoke GetProcAddress,g_hThemeDll,offset szOpenThemeData
	lea ecx,bstrButton
	push ecx
	push hWnd
	call eax
	mov g_hTheme,eax
	ret
OpenTheme endp

CloseTheme proc
	invoke GetProcAddress,g_hThemeDll,offset szCloseThemeData
	push g_hTheme
	call eax
	ret
CloseTheme endp

ZeroMemory proc uses edi  pMem:DWORD,nSize:DWORD
    cld
    xor eax,eax
    mov edi,pMem
    mov ecx,nSize
    shr ecx,2
    rep stosd
    mov ecx,nSize
    and ecx,3
    rep stosb
    ret
ZeroMemory endp

End
