include windows.inc
include user32.inc
include kernel32.inc
include gdi32.inc
include comctl32.inc
include winmm.inc

includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib comctl32.lib
includelib winmm.lib

;include debug.inc
;includelib debug.lib

;----------------------------------------------------------------------------
; Macros
;-------
$invoke MACRO vars:VARARG
	invoke vars
	EXITM <eax>
ENDM
;----------------------------------------------------------------------------
	
WinMain 					proto :DWORD,:DWORD,:DWORD,:DWORD
ButtonProc					proto :DWORD,:DWORD,:DWORD,:DWORD
PrepareImageRect 			proto :HWND,:DWORD,:DWORD,:DWORD,:BOOL,:DWORD,:DWORD,:DWORD
DrawTheIcon 				proto :HWND,:HDC,:DWORD,:DWORD,:DWORD,:BOOL,:BOOL
DrawTheBitmap				proto :HWND,:HDC,:DWORD,:DWORD,:DWORD,:BOOL,:BOOL
DrawBackground 				proto :HWND,:HDC,:DWORD
DrawTransparent				proto :HWND
DrawBorder					proto :HWND,:HDC,:DWORD
CreateGrayscaleIcon 		proto :HWND,:HICON
CreateBitmapMask 			proto :HBITMAP,:DWORD,:DWORD
SetSound 					proto :HWND,:DWORD,:DWORD
SetColor 					proto :HWND,:BYTE,:COLORREF
SetIcon 					proto :HWND,:DWORD,:DWORD
SetBitmap 					proto :HWND,:DWORD,:DWORD
SetDefaultColors			proto :HWND
PaintBk						proto :HWND,:HDC
PaintButton					proto :HWND
CancelHover 				proto :HWND
OpenTheme 					proto :HWND
CloseTheme					proto
FillSolidRect 				proto :HDC,:DWORD,:DWORD,:DWORD,:DWORD,:COLORREF
FreeResources				proto :HWND
ZeroMemory 					proto :DWORD,:DWORD
CreateButtonExClass 		proto :HINSTANCE

; Colours
BTNEXST_COLOR_BK_IN			equ 0			; Background color when mouse is INside
BTNEXST_COLOR_FG_IN			equ	4			; Text color when mouse is INside
BTNEXST_COLOR_BK_OUT		equ	8			; Background color when mouse is OUTside
BTNEXST_COLOR_FG_OUT		equ	12			; Text color when mouse is OUTside
BTNEXST_COLOR_BK_FOCUS		equ	16			; Background color when the button is focused
BTNEXST_COLOR_FG_FOCUS		equ	20			; Text color when the button is focused

; Visual styles
BTNEXST_ALIGN_HORIZ			equ 00000000h	; Icon/bitmap on the left, text on the right
BTNEXST_ALIGN_VERT			equ	00002000h	; Icon/bitmap on the top, text on the bottom
BTNEXST_ALIGN_HORIZ_RIGHT	equ	00004000h	; Icon/bitmap on the right, text on the left
BTNEXST_PRESSED_LEFTRIGHT 	equ 00000000h	; Pressed style from left to right (as usual)
BTNEXST_PRESSED_TOPBOTTOM 	equ 00000001h	; Pressed style from top to bottom
BTNEXST_XPBUTTON			equ 00008401h	; Draw xpstyle button
BTNEXST_FLAT				equ 00000209h	; Draw flat button
BTNEXST_NORMAL				equ 00000000h	; Draw normal push-button
BTNEXST_XPCHECKBOX			equ 00008101h	; Draw checkbox xpstyle
BTNEXST_FLATCHECKBOX		equ 00000309h	; Draw flat checkbox

; Theme styles
BP_PUSHBUTTON				equ 00000001h
BTNEX_THEME_NORMAL			equ 00000001h
BTNEX_THEME_HOT				equ 00000002h
BTNEX_THEME_PRESSED			equ 00000003h
BTNEX_THEME_DISABLED		equ 00000004h
BTNEX_THEME_DEFAULTED		equ 00000005h

; States
BTNEXS_FLAT					equ 00000001h
BTNEXS_ALWAYSTRACK			equ 00000002h
BTNEXS_MOUSEONBTN			equ 00000004h
BTNEXS_TRANSPARENT			equ 00000008h
BTNEXS_PRESSED				equ 00000010h
BTNEXS_FOCUSED				equ 00000020h
BTNEXS_DISABLED				equ 00000040h
BTNEXS_DEFAULT				equ 00000080h
BTNEXS_CHECKBOX				equ 00000100h
BTNEXS_BORDER				equ 00000200h
BTNEXS_FLATFOCUS			equ 00000400h
BTNEXS_DISABLEDIMAGE		equ 00000800h
BTNEXS_CHECK				equ 00001000h
BTNEXS_ALIGN				equ 00006000h
BTNEXS_USETHEME				equ 00008000h

; Messages
BTNEXM_SETBITMAP			equ WM_USER+100	;wParam =	nBitmapInID, lParam = nBitmapOutID
BTNEXM_SETICON				equ WM_USER+102	;wParam =	  nIconInID, lParam = nIconOutID
BTNEXM_SETCURSOR			equ WM_USER+103	;wParam = 	    hCursor, lParam = bRedraw
BTNEXM_SETTOOLTIPTEXT		equ WM_USER+104	;wParam =    nByteAlloc, lParam = lpText
BTNEXM_SETPRESSEDSTYLE		equ WM_USER+105	;wParam =   nPressStyle, lParam = bRedraw
BTNEXM_ALIGN_HORIZ			equ WM_USER+106	;wParam =	 		  0, lParam = 0
BTNEXM_ALIGN_VERT			equ WM_USER+107	;wParam =			  0, lParam = 0
BTNEXM_ALIGN_HORIZRIGHT		equ WM_USER+108	;wParam =			  0, lParam = 0
BTNEXM_SETBKGRCOL_IN		equ WM_USER+109	;wParam =	    crColor, lParam = 0
BTNEXM_SETTEXTCOL_IN		equ WM_USER+110	;wParam =	    crColor, lParam = 0
BTNEXM_SETBKGRCOL_OUT		equ WM_USER+111	;wParam =	    crColor, lParam = 0
BTNEXM_SETTEXTCOL_OUT		equ WM_USER+112	;wParam =	    crColor, lParam = 0
BTNEXM_SETBKGRCOL_FOCUS		equ WM_USER+113	;wParam =	    crColor, lParam = 0
BTNEXM_SETTEXTCOL_FOCUS		equ WM_USER+114	;wParam =	    crColor, lParam = 0
BTNEXM_SETDEFAULTCOLORS		equ WM_USER+115	;wParam =	          0, lParam = 0
BTNEXM_SETSOUND				equ WM_USER+116	;wParam = nSoundHoverID, lParam = nSoundClickID
BTNEXM_SETXPBUTTON			equ WM_USER+117	;wParam =			  0, lParam = 0
BTNEXM_SETDEFAULT			equ WM_USER+118	;wParam =			  0, lParam = 0
BTNEXM_SETFLAT				equ WM_USER+119	;wParam =			  0, lParam = 0
BTNEXM_SETNORMAL			equ WM_USER+120	;wParam =			  0, lParam = 0
BTNEXM_SETXPCHECKBOX		equ WM_USER+121	;wParam =			  0, lParam = 0
BTNEXM_SETFLATCHECKBOX		equ WM_USER+122	;wParam =			  0, lParam = 0
BTNEXM_SHOWDISABLEIMAGE		equ WM_USER+123 ;wParam =			  0, lParam = 0
BTNEXM_SETALWAYSTRACK		equ WM_USER+124	;wParam =			  0, lParam = 0

STRUCT_ICONS struct
	hIcon				HICON		?	; Handle to icon
	dwWidth 			DWORD		?	; Width of icon
	dwHeight			DWORD		?	; Height of icon
STRUCT_ICONS ends

STRUCT_BITMAPS struct
	hBitmap				HBITMAP		?	; Handle to bitmap
	hMask				HBITMAP		?	; Handle to mask bitmap
	dwWidth				DWORD		?	; Width of bitmap
	dwHeight			DWORD		?	; Height of bitmap
STRUCT_BITMAPS ends

STRUCT_SOUND struct	
	hMod				HMODULE		?	; Handle to module
	nSoundID			DWORD 		?	; Sound ID from resource
	dwFlags				DWORD		?	; Flags
STRUCT_SOUND ends

STRUCT_BUTTONEX struct
	szTitle				BYTE			256 dup (?)		; Buttom title
	crColors			COLORREF 		7 dup (?)		; Colors
	BitmapStructIn		STRUCT_BITMAPS	<>				; Bitmap when mouse is over button
	BitmapStructOut		STRUCT_BITMAPS	<>				; Bitmap when mouse is out of the button
	SoundStructOver		STRUCT_SOUND	<>				; Sound when mouse is over button
	SoundStructClick	STRUCT_SOUND	<>				; Sound when the button is clicked
	IconStructIn		STRUCT_ICONS	<>				; Icon when mouse is over button
	IconStructOut		STRUCT_ICONS	<>				; Icon when mouse is out of the button
	ptPressedOffset		POINT			<>				; Some offsets for pressed styles
	rcRect				RECT			<>				; Button window rect
	bmpBk				HBITMAP			?				; Background bitmap
	pbmpOldBk			HBITMAP			?				; Old background bitmap
	dcBk				HDC				?				; Background DC
	hCursor				HCURSOR			?				; Cursor when mouse is over button
	States				DWORD			?				; Button states (16 bit-flags)
	hDefaultFont		DWORD			?				; Selected font
	lpToolTipText		DWORD			?				; Long pointer to ToolTip text
	hToolTipWnd			HWND			?				; Handle to ToolTip window
STRUCT_BUTTONEX ends

.const
	szButton							db "Button",0
	szButtonEx							db "ButtonEx",0
	szUxThemeDll						db "UxTheme.dll",0
	szToolTips							db "Tooltips_class32",0
	szIsAppThemed						db "IsAppThemed",0
	szOpenThemeData						db "OpenThemeData",0
	szDrawThemeBackground				db "DrawThemeBackground",0
	szCloseThemeData					db "CloseThemeData",0
	szDrawThemeParentBackground 		db "DrawThemeParentBackground",0
	
	szIDEToolTip						db "ButtonEx",0
	szClassName							db "ButtonEx",0
	szCap								db "IDC_BUTTONEX",0
	szName								db "IDC_BUTTONEX",0

.data
	g_nDefBtnID				DWORD		0
	g_bHover 				BOOL 		TRUE
	g_hThemeDll				HINSTANCE	NULL		; Theme Dll instance
	g_hTheme				HANDLE		NULL		; Handle to current xp-theme
	g_nDllRefs				DWORD		0			; Reference counter
	
.data?
	g_ti					TOOLINFO	<?>
	g_hInstance 			HINSTANCE 	?